#include <stdio.h>
#include <stdlib.h>

void ucitaj(int n, int m, int a[][100])
{
    int i,j;
    for(i=0; i<n; i++)
    {
        for(j=0; j<m; j++)
        {
            scanf("%d", &a[i][j]);
        }
    }
}

int pronadji_index(int n, int m, int a[][100], int index2, int krajnji_index,int spoljnji_brojac)
{
    int i,pronadjen=-1, trenutno_stanje=a[index2][2],novo_stanje;
    for(i=0; i<n; i++)
    {
        if(i!=index2 && a[i][0]==a[index2][1])
        {
            pronadjen = i;
            novo_stanje = a[pronadjen][2];
            if(novo_stanje!=trenutno_stanje)
            {
                spoljnji_brojac++;
            }
            break;

        }
    }
    if(a[pronadjen][1]==krajnji_index)
    {
        return krajnji_index;
    }
    else if(pronadjen!=-1)
    {
        pronadji_index(n,m,a,pronadjen,krajnji_index,spoljnji_brojac);
    }
    else
    {
        return -1;
    }
}

int main()
{
    int m,a[100][100],broj_santi,spoljnji_brojac=0,minimalni=m+1,x,y,i;
    scanf("%d %d", &broj_santi, &m);
    ucitaj(m,3,a);
    scanf("%d %d",&x,&y);
    if(a[1][2]==1)
    {
        spoljnji_brojac=1;
    }
    for(i=0; i<m; i++)
    {
        pronadji_index(m,2,a,x,y,spoljnji_brojac);
        if(minimalni>spoljnji_brojac)
        {
            minimalni=spoljnji_brojac;
        }
    }
    printf("%d", spoljnji_brojac);
    return 0;
}